'use strict';
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const net_1 = require("net");
function getPort(port, host = 'localhost') {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            const server = net_1.createServer();
            server.unref();
            server.on('error', reject);
            server.listen({ port, host }, () => {
                const port = server.address().port;
                server.close(() => {
                    return resolve(port);
                });
            });
        }).catch(() => {
            return getPort(0, host);
        });
    });
}
exports.getPort = getPort;
